c       Theofanis V. Karambas
c       STOKES V method for nonlinear waves

	parameter (jm=5000)
	dimension zn(jm)

	WRITE (*,*)      
	write (*,*) 'input parameters'
	write (*,*)'||||||||||||||||||'
	write (*,*)'per=wave period, H=wave Height'
	write (*,*)'d=water depth'
	WRITE (*,*)
	
	open (3,file='ELEVS5.dat')

	write(*,*) 'period T, Height H, depth d =?'       
	read (*,*) per,H,d
	
	im=300
	
	pi=4.0*atan(1.0)
	omega=2*PI/per

	ALo=9.81*(PER**2)/(2*PI)
	ALNGHP=ALo



   39   AKAPA=2*PI/ALNGHP
	AKD=AKAPA*D
	CH2=COSH(2*AKD)
	s=1/ch2
	SH=SINH(AKD)
	TH=TANH(AKD)
	anl=1+((14.+4*CH2**2)*((pi*H/ALNGHP)**2)/16/SH**2)
	anl=1+(pi*H/ALNGHP)**2*(9*th**4-10*th**2+9)/8/th**4
	eps=(pi*H/ALNGHP)
	s1=(2+7.*s**2)/4/(1-s)**2
       s2=(4.+32.*s-116*s**2-400*s**3-71*s**4+146*s**5)/32./(1-s)**5  
	anl=1+(s1*eps**2)+s2*eps**4
	ALNGH=ALo*anl*TANH(AKD)
	DLEN=ABS(ALNGH-ALNGHP)
	IF (DLEN.GT.0.001) THEN
	ALNGHP=ALNGH
	GOTO 39
	ELSE
	END IF
	CEL=ALNGH/PER
	aL=ALNGH


	ur=H*aL**2/d**3
	if (ur.gt.40) then
	write(*,*) 'the solution is not accurate'
	write(*,*) 'since Ursell number Ur>40'
	stop
	else
	end if


	dx=aL/100

	akd=2.*pi*d/aL
	a2kd=4.*pi*d/aL
	ak=2.*pi/aL
	s=1.0/cosh(a2kd)
	sh=sinh(akd)
	c=cosh(ak*d)
	coh=(1./sinh(ak*d))
	eps=ak*H/2.


	A11=1./sh
	A13=-c**2*(5*c**2+1)/8./sh**5
	A15=-(1184*c**10-1440*c**8-1992*c**6+2641*c**4-249*c**2+18)
     !                              /1536/sh**11
	A22=3./8/sh**4
	A24=(192*c**8-424*c**6-312*c**4+480*c**2-17)/748/sh**10
	A33=(13-4*c**2)/64/sh**7
	A35=(412*c**12+4224*c**10-6800*c**8-12808*c**6+16704*c**4-
     !       3154*c**2+107)/4096/(6*c**2-1)/sh**13
	A44=(80*c**6-816*c**4+1338*c**2-197)/1536/(6*c**2-1)/sh**10
	par=61440*sh**11*(6*c**2-1)*(8*c**4-11*c**2+3)
	ar=2880*c**10-72480*c**8+324000*c**6-432000*c**4+163470*c**2
	A55=-(ar-16245)/par

	D2=-sqrt(1./tanh(akd))/2.
	D4=sqrt(1./tanh(akd))*(2+4*s+s**2+2*s**3)/(8*(1-s)**3)

	E2=tanh(akd)*(2+2*s+5*s**2)/(4*(1-s)**2)
	s32=(32.*(1-s)**5)
	s308=(8+12*s-152*s**2-308*s**3-42*s**4+77*s**5)
	E4=tanh(akd)*s308/s32

	cel=(Co+C2*eps**2+C4*eps**4)/rkg

	B22=cosh(akd)/sinh(akd)*((1+2.*s)/(2.-2.*s))

	B31a=1.+3.*s+3.*s**2+2.*s**3
	B31b=(1.-s)**3
	B31=-3.*B31a/(8*B31b)

	B42a=(6.-26.*s-182.*s**2-204.*s**3-25.*s**4+26.*s**5)
	B42b=6.*(3.+2.*s)*(1.-s)**4
	B42=cosh(akd)/sinh(akd)*(B42a/B42b)

	B44a=24.+92.*s+122.*s**2+66.*s**3+67.*s**4+34.*s**5
	B44b=24.*(3.+2.*s)*(1.-s)**4
	B44=cosh(akd)/sinh(akd)*(B44a/B44b)

	B53a1=-2687.*s**5+194.*s**6+467.*s**7+82.*s**8
	B53a=132.+17.*s-2216.*s**2-5897.*s**3-6292.*s**4+B53a1
	B53b=128.*(3.+2.*s)*(4.+s)*(1.-s)**6
	B53=9.*B53a/B53b

	B55a1=300.+1579.*s+3176.*s**2+2949.*s**3+1188.*s**4
	B55a2=675.*s**5+1326.*s**6+827.*s**7+130.*s**8
	B55a=5.*(B55a1+B55a2)
	B55b=384.*(3.+2.*s)*(4.+s)*(1.-s)**6
	B55=B55a/B55b
      
      
	E2=tanh(akd)*(2+2*s+5*s**2)/4./(1-s)**3
	E4=tanh(akd)*(8+12*s-152*s**2-308*s**3-42*s**4+77*s**5)/
     &  32./(1-s)**5
	
	D2=-.5*coh**.5
	D4=(coh**.5)*(2+4*s+s**2+2*s**3)/8./(1-s)**3.
	
	do 80 i=1,im

	x=i*dx
	akx=ak*x
	a2kx=2*ak*x
	a3kx=3*ak*x
	a4kx=4*ak*x
	a5kx=5*ak*x

	H1=eps/ak
	H2=B22*eps**2/ak
	H3=B31*eps**3/ak
	H4=eps**4/ak
	H5=eps**5/ak
      
	z1=H1*cos(akx)
	z2=H2*cos(a2kx)
	z3=H3*(cos(akx)-cos(a3kx))
	z4=H4*(B42*cos(a2kx)+B44*cos(a4kx))
	z5=H5*(-(B53+B55)*cos(akx)+B53*cos(a3kx)+B55*cos(a5kx))

	zn(i)=z1+z2+z3+z4+z5

	write(3,*) x/aL,zn(i)


80      continue



	stop
	end

